Ruby - Feature #1905

How about IPAddr#<=> to take care of mask_addr?
08/07/2009 06:31 PM - no6v (Nobuhiro IMAI)

Status: Rejected

Priority: Normal

Assignee: knu (Akinori MUSHA)
Target version: 2.0.0

Description

=begin

qooooo

#1877 1000000000000

IPAddr 000000000000000000000C000000D0O
Access Control List 10000000000

RUBY_DESCRIPTION

=> "ruby 1.9.2dev (2009-08-07 trunk 24440) [i686-linux]"
acl = {

?> IPAddr.new("192.168.2.0/29") => :admin,

?> IPAddr.new("192.168.2.0/24") => :user,

7>}

=> {#<IPAddr: IPv4:192.168.2.0/255.255.255.248>=>:admin, #<IPAddr: IPv4:192.168.2.0/255.255.255.0>=>:user}
acl.select{|r, | r === "192.168.2.56"}.max.last

=> user

acl.select{|r, | r === "192.168.2.1"}.max.last

=> user

00000000000000<=> 00 @addr 000000 @mask_addr O
0000 1pAdar D00000000000000000000000000
00000000o00o0no0bonDonhonooDD

00000000000000)y 1pAddr#== 0000000000000O
g0ooooooooooo

IPAddr.new("192.168.2.0/24") == IPAddr.new("192.168.2.0/32")
0 truell false(00000000000000D0000DDODOD

Nobuhiro IMAI nov@yo.rim.or.jp
Key fingerprint = F39E D552 545D 7C64 D690 F644 5A15 746C BD8E 7106

Index: lib/ipaddr.rb

--- lib/ipaddr.rb (revision 24440)

+++ lib/ipaddr.rb (working copy)

@@ -133,16 +133,10 @@ class IPAddr

# Returns a new ipaddr built by bitwise negation.
def ~

return self.clone.set(addr_mask(~@addr))

end

« Returns true if two ipaddrs are equal.
e def ==(other)

e other = coerce_other(other)
e return @family == other.family && @addr == other.to_i

e end
- Returns a new ipaddr built by masking IP address with the given
prefixlen/netmask. (e.g. 8, 64, "255.255.255.0", etc.)

def mask(prefixlen)

return self.clone.mask!(prefixlen)

end

@@ -325,11 +319,11 @@ class IPAddr
def <=>(other)

other = coerce_other(other)

return nil if other.family |= @family

¢ return @addr <=> other.to_i

e return [@addr, @mask_addr] <=> [other.to_i, other.mask_addr]
end
include Comparable

# Checks equality used by Hash.
def egl? (other)

@@ -372,10 +366,12 @@ class IPAddr
af, _to_string(@addr), _to_string(@mask_addr))
end

protected

e attr_reader :mask_addr

e def set(addr, *family)
case family[0] ? family[0] : @family
when Socket::AF_INET
if addr < 0 || addr > INAMASK
raise ArgumentError, "invalid address"
@@ -789,15 +785,24 @@ class TC_Operator < Test::Unit::TestCase
a = ~@in6_addr_any
assert_equal(INBMASK128, a.to_s)
assert_equal("::", @in6_addr_any.to_s)
end

e def test_equal
e assert_equal(true, @a == IPAddr.new("3ffe:505:2::"))

¢ def test_compare

e assert_equal(true, @a == IPAddr.new("3ffe:505:2::/48"))

e assert_equal(false, @a == IPAddr.new("3ffe:505:2::"))
assert_equal(false, @a == IPAddr.new("3ffe:505:3::"))
assert_equal(true, @a != IPAddr.new("3ffe:505:3::"))

e assert_equal(false, @a != IPAddr.new("3ffe:505:2::"))

assert_equal(false, @a != IPAddr.new("3ffe:505:2::/48"))
x = IPAddr.new("3ffe:505:3::/48")

y = IPAddr.new("3ffe:505:2::/64")

assert_equal(true, @a < x)

assert_equal(true, @a < y)

assert_equal(false, x < y)

min, max = [y, x, @a].minmax

assert_equal(@a, min)

assert_equal(x, max)

end
def test_mask
a = (@a.mask (32)
assert_equal ("3ffe:505::", a.to_s)

=end

Related issues:

Related to Ruby - Feature #1275: IPAddr unnecessarily destroys information on...

Rejected

03/12/2009

History

#1 - 08/14/2009 09:19 PM - no6v (Nobuhiro IMAI)

=begin
aooooo

From: Nobuhiro IMAI <nov_at_yo.rim.or.jp>
Date: Fri, 7 Aug 2009 18:31:36 +0900

00000000000000<=> D0@addr 000000 @mask_addr 00
0000 1pAdar 00000000000000O0000000000000
000000oDoDoooononoDoDoDonoDnaD

00000000000000) ipAddr#== 0000000000000
00obopopooooo

IPAddr.new("192.168.2.0/24") == IPAddr.new("192.168.2.0/32")
0 true [0 false 0000000000000000000000DOOD

00ooboooobooboca
« 000000000000D000D000D00 1PAqdr DDOODDOO

O0(PAddri#<=> [ @mask_addr 00000)
e <=> [l Comparable 000 == 0000000001PAddr#== 00000

000 [ruby-dev:39038] 0000000000000

Nobuhiro IMAI nov@yo.rim.or.jp
Key fingerprint = F39E D552 545D 7C64 D690 F644 5A15 746C BD8E 7106

=end

#2 - 09/12/2009 09:18 PM - no6v (Nobuhiro IMALI)

=begin
gooooo

From: Nobuhiro IMAI <nov_at_yo.rim.or.jp>
Date: Fri, 14 Aug 2009 21:19:42 +0900

0oooooooooooooon
« (1000000000000000000000 1PAdar 00000000
00(PAddri#<=> [ @mask_addr 00000)
e <=> [l Comparable (00 == 0000000001PAddr#== 00000

000 [ruby-dev:39038] 0000000000000

000000oDopoooonoboboDonoDoDO0noDnODD
IPAddr.new("192.168.2.0/24") == IPAddr.new("192.168.2.0/32")

0 true 00 faise 000000000000000000000O0OD

gopooooooooooo

Nobuhiro IMAI nov@yo.rim.or.jp
Key fingerprint = F39E D552 545D 7C64 D690 F644 5A15 746C BD8E 7106

=end
#3 - 09/28/2009 10:26 AM - znz (Kazuhiro NISHIYAMA)

=begin
At Sun, 27 Sep 2009 12:00:48 +0900,
Akinori MUSHA wrote:

00000000000000IPA«ar0000000000000
0000000000000000000PO0O00000000
000DoDoDoDoooonononong

000DoDoDoDooonooo

IPAddr.new("192.168.0.1/24") #=> #<IPAddr: IPv4:192.168.0.0/255.255.255.0>
IPAddr.new("192.168.0.2/24") #=> #<IPAddr: IPv4:192.168.0.0/255.255.255.0>

00000000000000newdO0OODODODODODODOODOD
000meO0000D0DODODODODODOODODOD

=end

#4 - 10/04/2009 01:40 PM - no6v (Nobuhiro IMAI)

=begin
aooooo

From: "Akinori MUSHA" <knu_at_iDaemons.org>
Date: Sun, 27 Sep 2009 12:00:48 +0900

« (1000000000000000000000 1PAddr D00OOOO00
00(IPAddr#<=> ] @mask_addr 00000)
o <=> [l Comparable 000 == 0000000001PAddr#== 00000

000 [ruby-dev:39038] 0000000000000

IPAddr.new("192.168.2.0/24") == IPAddr.new("192.168.2.0/32")

0 true 00 fatse 0000000000O00OO0DOODOO0OD
aooooooooooooo

00000000000000IPA«ar0000000000000
0000000000000000000PO0O0000000D
000DoDoDoDoooonononong

000000ODO00O00<=- 00000000000

000000000<=> [ include Comparable 0000 == 0000000
00000000==0000000000000000no0nannon
(0 == 0000000000DO000DOo00Dan

0000000000000000 <=-0000000ODDOD0O

00 a1 == a2 && (a1 <=>a2) != 0 0000000000000
I][II][II][II][II][II][II][II][II][II][II][II][II][II][II][I
0000DDDDDDDDDDDDDD

0000000APIOOO000000OOOOOOOOOOON
#mask_addr [ #prefixien 0000000000000
sort_by/max_by {]il [i, i.mask_addr] } 0000000000
00001onoooooomy

000000 class NetAddr < IPAddr 0000000000000
0000 == 0 <=> 0000000000000

Q00oo0ooobooooonoonDonnooD

gooooooooooooooooooOODDOOOOD
=end

#5 - 04/02/2010 08:27 AM - znz (Kazuhiro NISHIYAMA)

- Category set to lib

- Status changed from Open to Assigned
- Assignee set to knu (Akinori MUSHA)

- Target version set to 2.0.0

- Start date set to 08/07/2009

=begin

=end

#6 - 02/14/2012 10:55 PM - mame (Yusuke Endoh)
- Status changed from Assigned to Rejected

0000000000O00000DOrruby-core:42391] 0000

doooooooooooooDDoDDDDDDDDDDO
[ruby-dev:39381] [ruby-dev:39391]

000000000 AP ([ruby-dev:39391]) 00000000000
0000000000000000bonononon0no
000000000000000000000000000000D
00000000 reopen 00ODODODODODODODOD

FYI: znz 000000000 (000DODO e 0DODODOD,

0o https://bugs.ruby-lang.org/issues/1275 0ooooooooo

0000000000000000DO000 reopen DOODODO

Yusuke Endoh mame@tsg.ne.jp
